import es, playerlib, gamethread, os.path, cPickle, random, popuplib, services, usermsg


### Addon Info ###

info = es.AddonInfo() 
info['name']        = "Trivia" 
info['version']     = "1.0" 
info['author']      = "Bonbon AKA: Bonbon367" 
info['url']         = "http://addons.eventscripts.com/addons/view/trivia" 
info['description'] = "A trivia mod based on the popular IRC one." 

es.ServerVar('trivia_version', info['version'], 'Trivia made by Bonbon AKA Bonbon367').makepublic()

### Globals ###

questions = {}
bonus_points = {}
in_progress = False
sv = es.ServerVar
sv_options = {
	'trivia_admins': 'STEAM_0:0:11089864,mani_admins',
	'trivia_hints': 4,
	'trivia_unkown_letter': '-',
	'trivia_hint_delay': 60,
	'trivia_question_delay': 30,
	'trivia_players_in_top': 10,
	'trivia_max_menus': 10,
	'trivia_announce_commands': 1,
	'trivia_show_time_dividents': 10,
	'trivia_announce_powerup': 1,
	'trivia_scramble_chance': 10,
	'trivia_delete_streak_on_end': 1,
}
trivia_command_args = {
	'add': {
		'streak': [4, '<amount> <message>'],
		'question': [3, '<<question>|<answer>>'],
		'bonus': [5, '<attribute/weapon> <streak multiplier/chance (multiplied by streak)> <max amount> [min streak]'],
		'custombonus': [6, '<chance multiplier by players streak> <chance> <min level> <custom command to run>']
	},
	'del': {
		'streak': [3, '<amount>'],
		'question': [3, '<question>'],
	},
	'start': {
		'time': [3, '<time>'],
		'questions': [3, '<amount>'],
		'map': [2],
		'team': [3, '<questions>']
	},
	'stop': {
		'record': [2],
		'noscore': [2],
	}
}
help_commands = {
	'trivhelp': ['Show the Command menu (The one you just had open'],
	'trivrank': ['A menu that holds various things pertaining to score', 'The menu holds player info, top menu, your score and credits'],
	'trivia': ['An admin command that admins use to start/stop trivia'],
	'!question': ['If there\'s a game of trivia going on, it\'ll tell you the current question']
}
streaks = {}
player_data = {}
bonuses = {'weapons': {}, 'attributes': {}, 'custom': {}}
current_question = wmap = questions_left = time_left = curhint = teams = None
t_answers = ct_answers = spec_answers = hints = 0

### Loads ###

def load():
	if not es.exists('command', 'trivia'):
		es.regcmd('trivia', 'trivia/trivia_command')
	for option in sv_options:
		sv(option).set(sv_options[option])
	exec_config()
	Trivia().get_questions()
	for commandlist in [['trivia', 'trivia_admin'], ['trivrank', 'trivia_popup']]:
		regcmd(commandlist[0], commandlist[1])
		regcmd('!' + commandlist[0], commandlist[1])
	main_menu = popuplib.easymenu('Trivia Menu', '_popup_choice', main_menu_select)
	start_menu = popuplib.easymenu('Start Trivia', '_popup_choice', start_menu_select)
	player_menu = popuplib.easymenu('Trivia Info', '_popup_choice', player_menu_select)
	trivia_help_menu = popuplib.easymenu('Trivia Help', '_popup_choice', trivia_help_select)
	for option in ['trivrank', 'trivia', 'trivhelp', '!question']:
		trivia_help_menu.addoption(option, option)
	for option in ['Start', 'Stop', 'Cheat']:
		main_menu.addoption(option, option)
	for option in ['Time', 'Questions', 'Teams', 'Map']:
		start_menu.addoption(option, option)
	for option in ['Score', 'Top', 'Player Info', 'Credits']:
		player_menu.addoption(option, option)
	es.addons.registerSayFilter(check_input)
	player_db = es.getAddonPath('trivia') + '/player_info.db'
	if os.path.isfile(player_db):
		global player_data
		global player_data
		player_moo = open(player_db)
		player_data = cPickle.load(player_moo)
		player_moo.close()
	es.msg('#multi', '#lightgreen[Trivia]:#default By #LightgreenBonbon #default-- #lightgreenLoaded')

def unload():
	for command in ['trivia', 'trivrank']:
		unregcmd(command)
		unregcmd('!' + command)
	for popup_menu in ['Trivia Menu', 'Start Trivia', 'Trivia Info']:
		if popuplib.exists(popup_menu):
			popuplib.delete(popup_menu)
	for delay in ['hint_loop', 'time_loop']:
		gamethread.cancelDelayed(delay)
	es.addons.unregisterSayFilter(check_input)
	es.msg('#multi', '#lightgreen[Trivia]: #defaultBy #LightgreenBonbon #default-- #lightgreenUnloaded')

### Events ###

def est_map_end(ev):
	global wmap
	if wmap:
		wmap = False
		Trivia().stop()

def es_map_start(ev):
	exec_config()

def player_say(ev):
	userid = int(ev['userid'])
	text = ev['text'].lower()
	if in_progress:
		Trivia().check_answer(userid, text)
		if text == '!question':
			es.tell(userid, '#multi', '#lightgreen[Trivia]: #default the current question is #lightgreen' + current_question)
	if text == 'trivhelp':
		popuplib.send('Trivia Help', userid)


def round_start(ev):
	if int(sv('trivia_announce_commands')):
		for userid in es.getUseridList():
			gamethread.delayed(random.randint(1, 10), es.tell, (userid, '#multi', '#lightgreen[Trivia]: #defaultType #lightgreentrivrank or !trivrank#default in console or chat to access the info menu'))
			if es.getplayersteamid(userid) in str(sv('trivia_admins')):
				gamethread.delayed(random.randint(1, 10), es.tell, (userid, '#multi', '#lightgreen[Trivia]: #defaultType #lightgreentrivia or !trivia#default in console or chat to access admin commands'))

def player_changename(ev):
	Player(ev['userid']).check_keys()
	player_data[es.getplayersteamid(ev['userid'])]['name'] = ev['newname']

def player_spawn(ev):
	Player(ev['userid']).check_keys()
	player_data[es.getplayersteamid(ev['userid'])]['name'] = es.getplayername(ev['userid'])

### Classes ###`

class Trivia:

	def stop(self, announce=True, record=True):
		global in_progress, time_left, questions_left, wmap, hints, teams, t_answers, ct_answers, spec_answers
		if in_progress:
			for delay in ['hint_delay', 'time_loop']:
				gamethread.cancelDelayed(delay)
			if announce:
				if not teams:
					es.msg('#multi', '#lightgreen[Trivia]: #defaultGame of Trivia over, the winner is #lightgreen%s#default with #Lightgreen%s#default questions answered!'%self.return_winner)
				else:
					winner = 'No one'
					if spec_answers < t_answers > ct_answers:
						winner = 'Terrorists'
					elif spec_answers < ct_answers > t_answers:
						winner = 'Counter-Terrorists'
					elif ct_answers < spec_answers > t_answers:
						winner = 'Spectators'
					es.msg('#multi', '#lightgreen[Trivia]: #defaultGame of Trivia over, #lightgreen%s#default win%s!'%(winner, 's' if winner == 'No one' else ''))
			if record:
				self.save_data()
			time_left = questions_left = wmap = in_progress = teams = False
			hints = t_answers = ct_answers = spec_answers = 0
			if int(sv('trivia_delete_streak_on_end')):
				for steamid in player_data:
					player_data[steamid]['streak'] = 0

	def start(self, mapv=False, questions=False, time=False, teamsv=True):
		if not in_progress:
			global wmap, questions_left, time_left, teams, in_progress
			in_progress = True
			if mapv:
				wmap = True
			elif questions:
				questions_left = questions
			elif time:
				time_left = time
				self.time_loop()
			if teamsv:
				teams = True
			self.hint_loop()
		else:
			dbgmsg(0, 'Trivia Error: Multiple games of trivia trying to be started')
	
	def get_questions(self):
		if os.path.isfile(es.getAddonPath('trivia') + '/questions.txt'):
			a = open(es.getAddonPath('trivia') + '/questions.txt', 'r')
			b = a.readlines()
			a.close()
			for a in map(lambda x: x.split('|'), filter(lambda x: not x.startswith('//') and '|' in x, b)):
				questions[a[0]] = a[1].replace('\n', '').replace('\r', '').lower()
				if len(a) > 2:
					try:
						bonus_points[a[0]] = int(a[2])
					except ValueError:
						es.dbgmsg(0, 'Trivia Error: Invalid bonus for question ' + a[0])
		else:
			dbgmsg(0, 'Trivia Error: No questions.txt under ../addons/eventscripts/trivia/')
	
	def set_questions(self):
		a = open(es.getAddonPath('trivia') + '/questions.txt', 'w')
		for b in questions:
			a.write('%s|%s\n'%(b, questions[b]))
		a.close()
	
	def time_loop(self):
		global time_left
		if time_left > 0:
			time_left -= 1
			gamethread.delayedname(1, 'time_loop', self.time_loop)
			if not time_left % int(sv('trivia_show_time_dividents')):
				for userid in es.getUseridList():
					usermsg.hudhint(userid, 'Trivia Time Left %s'%time_left)
		else:
			self.stop()
	
	def hint_loop(self):
		if in_progress:
			global hints, curhint
			gamethread.delayedname(int(sv('trivia_hint_delay')), 'hint_loop', self.hint_loop)
			if not hints:
				global current_question
				if questions_left:
					global questions_left
					questions_left -= 1
					if not questions_left + 1:
						self.stop()
						return
					for userid in es.getUseridList():
						usermsg.hudhint(userid, 'Trivia Questions Left %s'%questions_left)
				hints += 1
				current_question = random.choice(questions.keys())
				curhint = str(sv('trivia_unkown_letter')) * len(questions[current_question])
				es.msg('#multi', '#lightgreen[Trivia]: #defaultNew Question -- #lightgreen' + current_question)
			elif hints < int(sv('trivia_hints')) + 1 and curhint.count(str(sv('trivia_unkown_letter'))) > 1:
				es.msg('#multi', '#lightgreen[Trivia]: Question - #default%s'%current_question)
				if random.randint(1, 100) > int(sv('trivia_scramble_chance')):
					curhint = list(curhint)
					while True:
						a = random.randint(0, len(curhint) - 1)
						if curhint[a] == str(sv('trivia_unkown_letter')):
							curhint[a] = questions[current_question][a]
							break
					curhint = ''.join(curhint)
					es.msg('#multi', '#lightgreen[Trivia]: #defaultCurrent hint #green[#lightgreen%s/%s#green] #lightgreen%s'%(hints, int(sv('trivia_hints')), curhint))
				else:
					es.msg('#multi', '#lightgreen[Trivia]: #defaultCurrent Hint #green[#lightgreen%s/%s#green] scrambled - #lightgreen%s'%(hints, int(sv('trivia_hints')), self.scramble(questions[current_question])))
				hints += 1
			else:
				es.msg('#multi', '#lightgreen[Trivia]: #defaultThe round is over, no one won! The answer was #lightgreen' + questions[current_question])
				hints = 0
				highest_streak = [None, None]
				for userid in es.getUseridList():
					steamid = es.getplayersteamid(userid)
					Player(userid).check_keys()
					if player_data[steamid]['streak'] > highest_streak[1]:
						highest_streak = [steamid, player_data[steamid]['streak']]
					player_data[steamid]['streak'] = 0
				if highest_streak[1]:
					es.msg('#multi', '#lightgreen[Trivia]: #defaultThere goes #lightgreen%s\'s#default streak of #lightgreen%s'%(es.getplayername(es.getuserid(highest_streak[0])), highest_streak[1]))
				gamethread.cancelDelayed('hint_loop')
				gamethread.delayedname(int(sv('trivia_question_delay')), 'hint_loop', self.hint_loop)

	def check_answer(self, userid, text):
		if current_question:
			if text.lower() == questions[current_question].lower():
				global hints, current_question
				hints = current_question = 0
				steamid = es.getplayersteamid(userid)
				gamethread.cancelDelayed('hint_loop')
				gamethread.delayedname(int(sv('trivia_question_delay')), 'hint_loop', self.hint_loop)
				es.msg('#multi', '#lightgreen[Trivia]: %s#default has won the round!'%es.getplayername(userid))
				player_data[steamid]['streak'] += 1
				player_data[steamid]['score'] += 1
				self.check_streak(userid)
				for userid2 in filter(lambda x: not es.getplayersteamid(x) == steamid, es.getUseridList()):
					player_data[steamid]['streak'] = 0
				Player(userid).check_bonus()
				if current_question in bonus_points:
					player_data[steamid]['score'] += bonus_points[current_question]
					es.msg('#multi', '#lightgreen[Trivia]: %s#default gained #lightgreen%s #defaultbonus points for the previous question!'%(es.getplayername(userid), bonus_points[current_question]))

	def check_streak(self, userid):
		steamid = es.getplayersteamid(userid)
		amount = player_data[steamid]['streak']
		if amount in streaks:
			es.msg('#multi', '#lightgreen[Trivia]: #default' + streaks[amount].replace('<player>', '#lightgreen%s#default'%es.getplayername(userid)).replace('\n', '').replace('\r', ''))

	def save_data(self):
		player_db = open(es.getAddonPath('trivia') + '/player_info.db', 'w')
		cPickle.dump(player_data, player_db)
		player_db.close()

	def return_winner(self):
		winner = 'No one'
		score = 0
		sid = None
		for steamid in player_data:
			if player_data[steamid]['temp score'] > score:
				winner = player_data[steamid]['name']
				score = player_data[steamid]['temp score']
				sid = steamid
			elif player_data[steamid]['temp score'] == score and score:
				winner = 'Tie between %s and %s'%(winner, player_data[steamid]['name'])
		if sid:
			player_data[sid]['wins'] += 1
			if teams:
				global ct_answers, t_answers
				if es.getplayerteam(userid) == 2:
					t_answers += 1
				elif es.getplayerteam(userid) == 3:
					ct_answers += 1
				else:
					spec_answers += 1
		return (winner, score)

	def scramble(self, word):
		scrambledsentance = []
		for w in word.split(' '):
			scrambledsentance.append(self.reorder(w))
		return ' '.join(scrambledsentance)

	def reorder(self, word):
		tempword = list(word)
		scrambled = []
		replaced = 0
		while replaced < len(word):
			a = random.randint(0, len(tempword) - 1)
			scrambled.append(tempword[a])
			tempword.pop(a)
			replaced += 1
		return ''.join(scrambled)

class Player:

	def __init__(self, userid=None, steamid=None):
		if userid:
			self.userid = int(userid)
			self.steamid = es.getplayersteamid(userid)
			self.check_keys()
		if steamid:
			self.steamid = steamid

	def check_keys(self):
		if self.steamid in player_data:
			keys = {'score': 0, 'streak': 0, 'name': es.getplayername(self.userid), 'choose time': False, 'temp score': 0, 'wins': 0}
			for key in keys:
				if not key in player_data[self.steamid]:
					player_data[self.steamid][key] = keys[key]
		else:
			player_data[self.steamid] = {}
			self.check_keys()

	def return_rank(self):
		return sorted(player_data, key=lambda x: player_data[x]['score'], reverse=True).index(self.steamid) + 1

	def check_bonus(self):
		for atr_bonus in bonuses['attributes']:
			if player_data[self.steamid]['streak'] >= bonuses['attributes'][atr_bonus]['min streak']:
				amount = bonuses['attributes'][atr_bonus]['multiplier'] * player_data[self.steamid]['streak']
				p = playerlib.getPlayer(self.userid)
				if atr_bonus == 'invisibility':
					p.set('color', [255, 255, 255, p.get('color')[3] - amount])
				else:
					p.set(atr_bonus, p.get(atr_bonus) + amount)
				if int(sv('trivia_announce_powerup')):
					es.msg('#multi', '#lightgreen[Trivia]: %s#default has gained a #lightgreen%s#default #lightgreen%s#default powerup!'%(es.getplayername(self.userid), amount, atr_bonus))
				else:
					es.tell(self.userid, '#multi', '#lightgreen[Trivia]: #defaultYou have gained a #lightgreen%s %s#default powerup!'%(amount, atr_bonus))
		for weapon_bonus in bonuses['weapons']:
			if player_data[self.steamid]['streak'] >= bonuses['weapons'][weapon_bonus]['min streak']:
				if random.randint(1, 100) <= bonuses['weapons'][weapon_bonus]['chance'] * player_data[self.steamid]['streak']:
					es.server.queuecmd('es_xgive %s weapon_%s'%(self.userid, weapon_bonus))
					if int(sv('trivia_announce_powerup')):
						es.msg('#multi', '#lightgreen[Trivia]: %s #defaulthas earned a #lightgreen%s#default!'%(es.getplayername(self.userid), weapon_bonus))
					else:
						es.tell(self.userid, '#multi', '#lightgreen[Trivia]: #defaultYou have gained a #lightgreen%s#default!'%weapon_bonus)
		for custom_bonus in bonuses['custom']:
			bargs = bonuses['custom'][custom_bonus]
			if random.randint(1, 100) <= (bargs[0] * player_data[self.steamid]['streak']) + bargs[1]:
				if player_data[self.steamid]['streak'] >= bargs[2]:
					es.server.queuecmd(custom_bonus.replace('<userid>', str(self.userid)).replace('<player>', es.getplayername(self.userid)))

### Returns ###

def is_authed(userid):
	if isAuthed(userid) or es.getplayersteamid(userid) in str(sv('trivia_admins')).replace(' ', '') or (es.getplayersteamid(userid) in return_admins() and 'mani_admins' in str(sv('trivia_admins'))):
		return True
	es.tell(userid, '#green', 'You are not authorized to run the command trivia!')

def return_admins():
	if os.path.isfile(es.getAddonPath('trivia').replace('addons/eventscripts/trivia', 'cfg/mani_admin_plugin/clients.txt')):
		admins = []
		a = open(es.getAddonPath('trivia').replace('addons/eventscripts/trivia', 'cfg/mani_admin_plugin/clients.txt'), 'r')
		b = a.readlines()
		a.close()
		c = []
		for a in b:
			a = a.replace('\t', '').replace(' ', '')
			if not a.startswith('//'):
				c.append(a)
		for a in c:
			if a.lower().startswith('"steam""steam_0:'):
				admins.append(a.lower().replace('"steam""', '').replace('"', '').replace('\n', '').upper())
		return admins

def menu_check(userid):
	count = popuplib.active(userid)['count']
	if count <= int(sv('trivia_max_menus')):
		return True
	es.tell(userid, '#multi', '#lightgreen[Trivia]: Maximum Popups Exceeded, server crashing nub')
	while count > int(sv('trivia_max_menus')):
		popuplib.close(popuplib.active(userid)['name'], userid)
		count -= 1
	return False

### Commands ###

def trivia_admin():
	userid = es.getcmduserid()
	args = es.getargs()
	if is_authed(userid):
		if args:
			es.server.queuecmd('trivia ' + args)
			es.tell(userid, '#multi', '#lightgreen[Trivia]: #defaultExecuted a trivia command, check your console to check for details')
		else:
			popuplib.send('Trivia Menu', userid)
	else:
		es.tell(userid, '#multi', '#lightgreen[Trivia]: #defaultYou are not authorized to run the command #Lightgreentrivia!')

def trivia_popup():
	if menu_check(es.getcmduserid()):
		popuplib.send('Trivia Info', es.getcmduserid())

def trivia_command():
	args = es.getargs()
	if args:
		args = args.lower().replace('"', '').split(' ')
		if len(args) >= 2:
			if args[0] in trivia_command_args:
				if args[1] in trivia_command_args[args[0]]:
					if len(args) >= trivia_command_args[args[0]][args[1]][0]:
						if args[0] == 'add':
							if args[1] == 'question':
								question = ' '.join(args[2:])
								if '|' in question:
									answer = question[question.find('|') + 1:].lower()
									question = question[0:question.find('|')]
									if not question in questions:
										questions[question] = answer
									else:
										dbgmsg(0, 'Trivia Error: Question Already Exists!')
								else:
									dbgmsg(0, 'Trivia Error: Answer not provided for question!')
									dbgmsg(0, 'Trivia Syntax: Seperate your question and your answer with a |')
									dbgmsg(0, 'Trivia Syntax: It is important that you have no spaces between <question>, | and <answer>')
									dbgmsg(0, 'Trivia Syntax: A valid question would be "Do I like pie?|yes"')
							elif args[1] == 'streak':
								if args[2].isdigit():
									message = ' '.join(args[3:])
									streaks[int(args[2])] = message
								else:
									dbgmsg(0, 'Trivia Error: Invalid amount for trivia add streak, %s'%args[2])
									dbgmsg(0, 'Trivia Syntax: trivia add streak <amount> <message>')
							elif args[1] == 'bonus':
								min_streak = 1
								if len(args) > 5:
									try:
										min_streak = int(args[5])
									except ValueError:
										dbgmsg(0, 'Trivia Error: Invalid amount for optional parameter, %s'%args[5])
										return
								try:
									float(args[3])
								except ValueError:
									dbgmsg(0, 'Trivia Error: Invalid amount for trivia add bonus %s, %s'%(args[2], args[3]))
									return
								try:
									float(args[4])
								except ValueError:
									dbgmsg(0, 'Trivia Error: Invalid amount for trivia add bonus %s, %s'%(args[2], args[4]))
									return
								if args[2] in ['health', 'speed', 'invisibility', 'cash']:
									bonuses['attributes'][args[2]] = {'multiplier': float(args[3]), 'max': float(args[4]), 'min streak': min_streak}
								else:
									bonuses['weapons'][args[2]] = {'chance': float(args[3]), 'max': float(args[4]), 'min streak': min_streak}
							elif args[1] == 'custombonus':
								try:
									min_chance = float(args[2])
								except:
									es.dbgmsg(0, 'Trivia Error: Invalid chance multiplier for trivia add custombonus, %s'%args[2])
									return
								if args[3].isdigit():
									if args[4].isdigit():
										bonuses['custom'][' '.join(args[5:])] = [min_chance, int(args[3]), int(args[4])]
									else:
										es.dbgmsg(0, 'Trivia Error: Invalid level for trivia add custombonus, %s'%args[4])
								else:
									es.dbgmsg(0, 'Trivia Error: Invalid chance for trivia add custombonus, %s'%args[3])
						elif args[0] == 'del':
							if args[1] == 'question':
								question = ' '.join(args[2:])
								if question in questions:
									global questions
									del questions[question]
								else:
									dbgmsg(0, 'Trivia Error: No Trivia question %s!'%question)
							elif args[1] == 'streak':
								if args[2].isdigit():
									if int(args[2]) in streaks:
										global streaks
										del streaks[int(args[2])]
									else:
										dbgmsg(0, 'Trivia Error: No streak for %s!'%args[2])
								else:
									dbgmsg(0, 'Trivia Error: Invalid amount for trivia del streak, %s'%args[2])
									dbgmsg(0, 'Trivia Syntax: trivia del streak <amount> <message>')
						elif args[0] == 'stop':
							if args[1] == 'record':
								Trivia().stop(record=False)
							else:
								Trivia().stop()
						elif args[0] == 'start':
							if args[1] == 'time':
								if args[2].isdigit():
									Trivia().start(time=int(args[2]))
								else:
									dbgmsg(0, 'Trivia Error: Invalid time for trivia start time, %s'%args[2])
									dbgmsg(0, 'Trivia Syntax: trivia start time <time>')
							elif args[1] == 'map':
								Trivia().start(mapv=True)
							elif args[1] == 'questions':
								if args[2].isdigit():
									Trivia().start(questions=int(args[2]))
								else:
									dbgmsg(0, 'Trivia Error: Invalid amount for trivia start question, %s'%args[2])
									dbgmsg(0, 'Trivia Syntax: trivia start questions <amount>')
							elif args[1] == 'team':
								if args[2].isdigit():
									Trivia().start(questions=int(args[2]), teamsv=True)
					else:
						dbgmsg(0, 'Trivia Error: Invalid arguments for trivia %s %s'%(args[0], args[1]))
						dbgmsg(0, 'Trivia Syntax: trivia %s %s %s'%(args[0], args[1], trivia_command_args[args[0]][args[1]][1]))
				else:
					dbgmsg(0, 'Trivia Error: No subcommand for trivia %s, %s'%(args[0], args[1]))
					dbgmsg(0, 'Trivia %s Commands: %s'%(args[0], ', '.join(trivia_command_args[args[0]].keys())))
			else:
				dbgmsg(0, 'Trivia Error: No subcommand for trivia, %s'%args[0])
				dbgmsg(0, 'Trivia Commands: %s'%', '.join(trivia_command_args.keys()))
		else:
			dbgmsg(0, 'Trivia Error: Not enough arguments for trivia to continue')
	else:
		dbgmsg(0, 'Trivia Error: Not enough arguments to continue')
		dbgmsg(0, 'Trivia Commands: %s'%', '.join(trivia_command_args.keys()))
	Trivia().set_questions()

### Popups ###

def main_menu_select(userid, choice, popupid):
	if choice == 'Start':
		popuplib.send('Start Trivia', userid)
	elif choice == 'Stop':
		if in_progress:
			Trivia().stop()
			es.tell(userid, '#multi', '#lightgreen[Trivia]: #defaultStoping current game of Trivia')
		else:
			es.tell(userid, '#multi', '#lightgreen[Trivia]: #defaultNo game in progress!')
	elif choice == 'Cheat':
		if in_progress:
			es.tell(userid, '#multi', '#lightgreen[Trivia]: #defaultHah! You think I\'d tell you that the answer is #lightgreen%s#default, you stupid cheater?'%questions[current_question])
		else:
			es.tell(userid, '#multi', '#lightgreen[Trivia]: #defaultThere isn\'t a game of trivia currently in progress!')

def start_menu_select(userid, choice, popupid):
	if choice == 'Time':
		player_data[es.getplayersteamid(userid)]['choose time'] = 'time'
		es.tell(userid, '#multi', '#lightgreen[Trivia]: #defaultType an integer into chat to chose a time')
	elif choice == 'Questions':
		player_data[es.getplayersteamid(userid)]['choose time'] = 'questions'
		es.tell(userid, '#multi', '#lightgreen[Trivia]: #defaultType an integer into chat to chose an amount of questions')
	elif choice == 'Teams':
		player_data[es.getplayersteamid(userid)]['choose time'] = 'team'
		es.tell(userid, '#multi', '#lightgreen[Trivia]: #defaultType an integer into chat to chose an amount of questions')
	else:
		es.cexec(userid, 'trivia start map')

def player_menu_select(userid, choice, popupid):
	Player(userid).check_keys()
	if choice == 'Score':
		Player(userid).check_keys()
		es.tell(userid, '#multi', '#lightgreen[Trivia]: #defaultYou are ranked #lightgreen%s/%s'%(Player(userid).return_rank(), len(player_data)))
		es.tell(userid, '#multi', '#lightgreen[Trivia]: #defaultYou have a score of #lightgreen%s#default and #lightgreen%s#default wins'%(player_data[es.getplayersteamid(userid)]['score'], player_data[es.getplayersteamid(userid)]['wins']))
		es.tell(userid, '#multi', '#lightgreen[Trivia]: #defaultYou have a streak of #lightgreen%s#default!'%(player_data[es.getplayersteamid(userid)]['streak']))
	elif choice == 'Top':
		t___t = int(sv('trivia_players_in_top'))
		top = popuplib.easymenu('Trivia Top', '_popup_choice', top_select)
		for e in sorted(player_data, key=lambda x: player_data[x]['score'], reverse=True):
			t___t -=1
			if t___t >= 0:
				top.addoption(e, '%s: %s'%(player_data[e]['name'], player_data[e]['score']))
		if menu_check(userid):
			popuplib.send('Trivia Top', userid)
	elif choice == 'Player Info':
		player_info = popuplib.easymenu('Trivia Player Info', '_popup_choice', player_info_select)
		for userid2 in es.getUseridList():
			player_info.addoption(es.getplayersteamid(userid2), es.getplayername(userid2))
		if menu_check(userid):
			popuplib.send('Trivia Player Info', userid)
	elif choice == 'Credits':
		pass

def top_select(userid, choice, popupid):
	es.tell(userid, '#multi', '#lightgreen[Trivia]: %s#default is ranked #lightgreen%s/%s'%(player_data[choice]['name'], Player(steamid=choice).return_rank(), len(player_data)))
	es.tell(userid, '#multi', '#lightgreen[Trivia]: %s#default has a score of #lightgreen%s#default and #lightgreen%s#default wins'%(player_data[choice]['score'], player_data[choice]['wins']))

def player_info_select(userid, choice, popupid):
	es.tell(userid, '#multi', '#lightgreen[Trivia]: %s#default is ranked #lightgreen%s/%s'%(player_data[choice]['name'], Player(steamid=choice).return_rank(), len(player_data)))
	es.tell(userid, '#multi', '#lightgreen[Trivia]: %s#default has a score of #lightgreen%s#default and #lightgreen%s#default wins'%(player_data[choice]['score'], player_data[choice]['wins']))

def trivia_help_select(userid, choice, popupid):
	for text in help_commands[choice]:
		es.tell(userid, '#multi', '#lightgreen[Trivia]:#default ' + text)

### Functions ###

def exec_config():
	if os.path.isfile(es.getAddonPath('trivia') + '/trivia.cfg'):
		es.server.queuecmd('es_xmexec ../addons/eventscripts/trivia/trivia.cfg')
	else:
		dbgmsg(0, 'Trivia Error: No trivia.cfg under ../addons/eventscripts/trivia/')

def regcmd(command, block):
	if not es.exists('saycommand', command):
		es.regsaycmd(command, 'trivia/' + block)
	if not es.exists('clientcommand', command):
		es.regclientcmd(command, 'trivia/' + block)

def unregcmd(command):
	if es.exists('saycommand', command):
		es.unregsaycmd(command)
	if es.exists('clientcommand', command):
		es.unregclientcmd(command)

def dbgmsg(zero, message):
	es.dbgmsg(0, message)
	for userid in filter(lambda x: es.getplayersteamid(x) in str(sv('trivia_admins')), es.getUseridList()):
		es.cexec(userid, 'echo ' + message)

def setup_auth(): # Thanks, SD
	global isAuthed
	if services.isRegistered('auth'):
		auth_service = services.use('auth')
		auth_service.registerCapability('trivia_admin', auth_service.ADMIN)
		isAuthed = lambda x: auth_service.isUseridAuthorized(x, 'trivia_admin')
	else:
		isAuthed = lambda x: False

setup_auth()

### Filters ###

def check_input(userid, text, teamonly):
	Player(userid).check_keys()
	if player_data[es.getplayersteamid(userid)]['choose time']:
		text = text.replace(' ', '').replace('"', '')
		if text.isdigit():
			es.cexec(userid, 'trivia start %s %s'%(player_data[es.getplayersteamid(userid)]['choose time'], int(text)))
		else:
			es.tell(userid, '#multi', '#lightgreen[Trivia]: #defaultInvalid amount, #lightgreen' + text)
		player_data[es.getplayersteamid(userid)]['choose time'] = False
		return None, None, None
	return userid, text, teamonly


